/*
 * Definitions etc. for regexp(3) routines.
 *
 * See regexp.cpp for licence & copyrigth etc.
 */

#define NSUBEXP           10 /* Don't change this without changing the code */
#define MAX_ERR_MSG_SIZE 128

typedef enum
{
  FALSE, TRUE
}BOOL;

class reg_exp_class
{
  struct regexp_type *prog;
  const char *regparse;    /* Input-scan pointer. */
  int regnpar;             /* () count. */
  char regdummy;
  char *regcode;           /* Code-emit pointer; &regdummy = don't. */
  long regsize;            /* Code size. */

  const char *reginput;    /* String-input pointer. */
  const char *regbol;      /* Beginning of input, for ^ check. */
  char *reg(int paren, int *flagp);
  char *regbranch(int *flagp);
  char *regpiece(int *flagp);
  char *regatom(int *flagp);
  char *regnode(char op);
  char *regnext(char *p);
  void regc(char b);
  void reginsert(char op, char *opnd);
  void regtail(char *p, char *val);
  void regoptail(char *p, char *val);
  const char *regtry(const char *string);
  const char *regmatch(char *prog, int nest);
  int  regrepeat(char *p);
  char err_msg[MAX_ERR_MSG_SIZE];
  void regerror(const char *msg);
  int  reg_len;
  int  max_len;

public:
  reg_exp_class();
  ~reg_exp_class();
  BOOL compile(const char *exp);
  const char *find(const char *string, int *len = NULL);
  const char *get_last_error(void);
  void clear_error(void);
};

